package siprp.database.cayenne.objects;

import java.util.List;

import siprp.database.cayenne.objects.auto._Prestadores;

import com.evolute.utils.strings.UnicodeChecker;

public class Prestadores extends _Prestadores {

	private static final long serialVersionUID = 1L;

	private String name = null;
	
	private String convertedName = null;
	
	public static final Prestadores prestadorNulo = new Prestadores();
	
	static {
		prestadorNulo.setNome( "SIPRP" );
	}
	
	@Override
	public String getNome()
	{
		String currentName = super.getNome();
		if( name == null || !name.equals( currentName ))
		{
			name = currentName;
			convertedName = null;
		}
		return convertName();
	}
	
	@Override
	public void setNome( String nome )
	{
		super.setNome( UnicodeChecker.parseToUnicode( nome ) );
		getNome();
	}

	private String convertName()
	{
		if( name == null )
		{
			convertedName = null;
		}
		else
		{
			convertedName = UnicodeChecker.parseFromUnicode( name );
		}
		return convertedName;
	}

//	public static Prestadores getDefaultPrestador()
//	{
//		return medicinaProvider.getDefaultPrestador();
//	}
	
	public static List<Prestadores> getAllPrestadores()
	{
		List<Prestadores> result = medicinaProvider.getAllPrestadores();
		result.add( 0, prestadorNulo);
		return result;
	}
	
	@Override
	public String toString()
	{
		return getNome();
	}
}



